/*
 * Decompiled with CFR 0_114.
 */
package com.gudenau.haxserver;

import com.gudenau.haxserver.HTTPPropriety;
import com.gudenau.haxserver.HTTPRequest;
import com.gudenau.haxserver.Stagefright;
import com.gudenau.haxserver.SystemVersions;
import com.gudenau.haxserver.Util;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.Socket;
import java.util.ArrayList;

public class HaxClient
implements Runnable {
    private final Socket socket;
    private static final File dataFile = new File("./data");
    private static /* synthetic */ int[] $SWITCH_TABLE$com$gudenau$haxserver$SystemVersions;

    static {
        dataFile.mkdirs();
    }

    public HaxClient(Socket socket) {
        this.socket = socket;
    }

    @Override
    public void run() {
        try {
            InputStream in = this.socket.getInputStream();
            OutputStream out = this.socket.getOutputStream();
            HTTPRequest header = this.getRequest(in);
            String path = header.getPath();
            SystemVersions version = SystemVersions.getSystemVersion(header.getPropriety("User-Agent"));
            if (version != null) {
                if (path.indexOf(63) != -1) {
                    this.serveHax(version, out, header);
                } else {
                    this.serveError(out);
                }
            } else {
                this.serveFile(out, header);
            }
            in.close();
            out.close();
            this.socket.close();
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void serveFile(OutputStream out, HTTPRequest header) throws IOException {
        this.writeHeader(new BufferedWriter(new OutputStreamWriter(out)), null);
        System.out.println(header.getPath());
        File file = header.getPath().equals("/") ? new File(dataFile, "/index.html") : new File(dataFile, header.getPath());
        System.out.println(file);
        out.write(Util.readFile(file));
        out.flush();
    }

    private void serveError(OutputStream out) throws IOException {
        BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(out));
        this.writeHeader(writer, "text/html");
        writer.write("<html><head><title>Error</title></head><body><p>There was an error</p></body></html>");
        writer.flush();
    }

    private void writeHeader(BufferedWriter writer, String contentType) throws IOException {
        writer.write("HTTP/1.1 200 OK\r\n");
        if (contentType != null) {
            if (contentType.contains("video")) {
                writer.write("Transfer-Encoding: chunked\r\n");
            }
            writer.write("Content-Type: ");
            writer.write(contentType);
            writer.write("\r\n");
        }
        writer.write("\r\n");
        writer.flush();
    }

    private void serveHax(SystemVersions systemVersion, OutputStream out, HTTPRequest header) throws Exception {
        BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(out));
        if (-1 == header.getPath().indexOf(63)) {
            this.serveError(out);
            return;
        }
        String payloadName = header.getPath().substring(header.getPath().indexOf(63) + 1);
        System.out.println(payloadName);
        switch (HaxClient.$SWITCH_TABLE$com$gudenau$haxserver$SystemVersions()[systemVersion.ordinal()]) {
            case 1: 
            case 2: 
            case 3: 
            case 4: 
            case 15: 
            case 16: 
            case 17: 
            case 28: 
            case 29: {
                System.out.println(systemVersion.name());
                this.writeHeader(writer, "video/mp4");
                Stagefright.serveHax(out, systemVersion, header, String.valueOf(payloadName) + ".bin");
                break;
            }
            default: {
                this.serveError(out);
            }
        }
    }

    private HTTPRequest getRequest(InputStream in) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(in));
        String line = reader.readLine();
        String[] splitLine = line.split(" ");
        String method = splitLine[0].trim();
        String path = splitLine[1].trim();
        String protocol = splitLine[2].trim();
        ArrayList<HTTPPropriety> props = new ArrayList<HTTPPropriety>();
        line = reader.readLine();
        while (line != null && !line.isEmpty()) {
            splitLine = line.split(":", 2);
            props.add(new HTTPPropriety(splitLine[0].trim(), splitLine[1].trim()));
            line = reader.readLine();
        }
        return new HTTPRequest(method, protocol, path, props);
    }

    static /* synthetic */ int[] $SWITCH_TABLE$com$gudenau$haxserver$SystemVersions() {
        int[] arrn;
        int[] arrn2 = $SWITCH_TABLE$com$gudenau$haxserver$SystemVersions;
        if (arrn2 != null) {
            return arrn2;
        }
        arrn = new int[SystemVersions.values().length];
        try {
            arrn[SystemVersions.EU_2_0_0.ordinal()] = 27;
        }
        catch (NoSuchFieldError v1) {}
        try {
            arrn[SystemVersions.EU_2_1_0.ordinal()] = 26;
        }
        catch (NoSuchFieldError v2) {}
        try {
            arrn[SystemVersions.EU_4_0_0.ordinal()] = 25;
        }
        catch (NoSuchFieldError v3) {}
        try {
            arrn[SystemVersions.EU_5_0_0.ordinal()] = 24;
        }
        catch (NoSuchFieldError v4) {}
        try {
            arrn[SystemVersions.EU_5_1_0.ordinal()] = 23;
        }
        catch (NoSuchFieldError v5) {}
        try {
            arrn[SystemVersions.EU_5_1_1.ordinal()] = 22;
        }
        catch (NoSuchFieldError v6) {}
        try {
            arrn[SystemVersions.EU_5_1_2.ordinal()] = 21;
        }
        catch (NoSuchFieldError v7) {}
        try {
            arrn[SystemVersions.EU_5_2_0.ordinal()] = 20;
        }
        catch (NoSuchFieldError v8) {}
        try {
            arrn[SystemVersions.EU_5_3_0.ordinal()] = 19;
        }
        catch (NoSuchFieldError v9) {}
        try {
            arrn[SystemVersions.EU_5_3_1.ordinal()] = 18;
        }
        catch (NoSuchFieldError v10) {}
        try {
            arrn[SystemVersions.EU_5_3_2.ordinal()] = 17;
        }
        catch (NoSuchFieldError v11) {}
        try {
            arrn[SystemVersions.EU_5_4_0.ordinal()] = 16;
        }
        catch (NoSuchFieldError v12) {}
        try {
            arrn[SystemVersions.EU_5_5_0.ordinal()] = 15;
        }
        catch (NoSuchFieldError v13) {}
        try {
            arrn[SystemVersions.JP_2_1_0.ordinal()] = 38;
        }
        catch (NoSuchFieldError v14) {}
        try {
            arrn[SystemVersions.JP_4_0_0.ordinal()] = 37;
        }
        catch (NoSuchFieldError v15) {}
        try {
            arrn[SystemVersions.JP_5_0_0.ordinal()] = 36;
        }
        catch (NoSuchFieldError v16) {}
        try {
            arrn[SystemVersions.JP_5_1_0.ordinal()] = 35;
        }
        catch (NoSuchFieldError v17) {}
        try {
            arrn[SystemVersions.JP_5_1_1.ordinal()] = 34;
        }
        catch (NoSuchFieldError v18) {}
        try {
            arrn[SystemVersions.JP_5_1_2.ordinal()] = 33;
        }
        catch (NoSuchFieldError v19) {}
        try {
            arrn[SystemVersions.JP_5_2_0.ordinal()] = 32;
        }
        catch (NoSuchFieldError v20) {}
        try {
            arrn[SystemVersions.JP_5_3_0.ordinal()] = 31;
        }
        catch (NoSuchFieldError v21) {}
        try {
            arrn[SystemVersions.JP_5_3_1.ordinal()] = 30;
        }
        catch (NoSuchFieldError v22) {}
        try {
            arrn[SystemVersions.JP_5_3_2.ordinal()] = 29;
        }
        catch (NoSuchFieldError v23) {}
        try {
            arrn[SystemVersions.JP_5_4_0.ordinal()] = 28;
        }
        catch (NoSuchFieldError v24) {}
        try {
            arrn[SystemVersions.US_2_0_0.ordinal()] = 14;
        }
        catch (NoSuchFieldError v25) {}
        try {
            arrn[SystemVersions.US_2_1_0.ordinal()] = 13;
        }
        catch (NoSuchFieldError v26) {}
        try {
            arrn[SystemVersions.US_4_0_0.ordinal()] = 12;
        }
        catch (NoSuchFieldError v27) {}
        try {
            arrn[SystemVersions.US_5_0_0.ordinal()] = 11;
        }
        catch (NoSuchFieldError v28) {}
        try {
            arrn[SystemVersions.US_5_1_0.ordinal()] = 10;
        }
        catch (NoSuchFieldError v29) {}
        try {
            arrn[SystemVersions.US_5_1_1.ordinal()] = 9;
        }
        catch (NoSuchFieldError v30) {}
        try {
            arrn[SystemVersions.US_5_1_2.ordinal()] = 8;
        }
        catch (NoSuchFieldError v31) {}
        try {
            arrn[SystemVersions.US_5_2_0.ordinal()] = 7;
        }
        catch (NoSuchFieldError v32) {}
        try {
            arrn[SystemVersions.US_5_3_0.ordinal()] = 6;
        }
        catch (NoSuchFieldError v33) {}
        try {
            arrn[SystemVersions.US_5_3_1.ordinal()] = 5;
        }
        catch (NoSuchFieldError v34) {}
        try {
            arrn[SystemVersions.US_5_3_2.ordinal()] = 4;
        }
        catch (NoSuchFieldError v35) {}
        try {
            arrn[SystemVersions.US_5_4_0.ordinal()] = 3;
        }
        catch (NoSuchFieldError v36) {}
        try {
            arrn[SystemVersions.US_5_5_0.ordinal()] = 2;
        }
        catch (NoSuchFieldError v37) {}
        try {
            arrn[SystemVersions.US_5_5_1.ordinal()] = 1;
        }
        catch (NoSuchFieldError v38) {}
        $SWITCH_TABLE$com$gudenau$haxserver$SystemVersions = arrn;
        return $SWITCH_TABLE$com$gudenau$haxserver$SystemVersions;
    }
}

